LPARAM lcDirs,lcFile
* lcDirs - Seznam adres
* lcFile - Vstupn soubor

LOCAL lcAlias,lcAliasD,liCount,lii,liy,liz,lcDir,liRecno,lcPom,lcPom2,;
      lcFile,lcFile2,llDal,llErr,lcErr,llFirst,liT1,liT2,lcSESC,lcOESC
      
PRIVATE llESC

LOCAL ARRAY laFiles(1)
CLEAR
lcAlias=SYS(2015)
lcAliasD=SYS(2015)

IF !__StartDoc(lcFile)
   =MESSAGEBOX("Nepodailo se vytvoit vstupn soubor.",48,"File compare")
   RETURN
ENDIF

lcSESC=SET("ESCAPE")
lcOESC=ON("ESCAPE")

SET ESCAPE ON
ON ESCAPE llESC=.T.
llESC=.F.

liT1=SECO()
CREATE CURSOR (lcAlias) (XX000 C(254),XX001 I)
CREATE CURSOR (lcAliasD) (XX000 C(254))

lcDirs=ALLT(lcDirs)
lcDirs=lcDirs+IIF(RIGHT(lcDirs,1)=',','',',')
STORE OCCURS(',',lcDirs) TO liCount && Count of item

* Vytvo zkladn seznam adres
liy=1
FOR lii=1 TO liCount
    IF llESC
       EXIT
    ENDIF
    liz=AT(',',lcDirs,lii)
    lcDir=ALLT(SUBST(lcDirs,liy,liz-liy))
    lcDir=lcDir+IIF(RIGHT(lcDir,1)="\","","\")
 
    IF !EMPTY(lcDir)
       INSERT INTO (lcAliasD) (XX000) VALUES (lcDir)
    ENDIF
    liy=liz+1
NEXT

IF !llESC
   * Prochzej seznam adres a nati seznam soubor v nich
   SELE (lcAliasD)
   SCAN WHILE !llESC
        lcDir=ALLT(XX000)
        liRecno=RECNO() && Zapamatuj si vtu
        liCount=ADIR(laFiles,lcDir+"*.*","ARSHD")

        FOR lii=1 TO liCount
            IF laFiles(lii,1)="." OR laFiles(lii,1)=".."
               LOOP
            ENDIF

            IF AT("D",laFiles(lii,5))>0 && Adres
               INSERT INTO (lcAliasD) (XX000) VALUES (lcDir+laFiles(lii,1)+"\")
            ELSE
               IF laFiles(lii,2)>0
                  * Jinak je to soubor
                  INSERT INTO (lcAlias) (XX000, XX001) VALUES (lcDir+laFiles(lii,1),laFiles(lii,2))
               ENDIF
            ENDIF
        NEXT

        SELE (lcAliasD)
        GO (liRecno) && Sko na pvodn vtu
   ENDSCAN
ENDIF

\<<DATETIME()>>
\Vstupn adres(e): <<lcDirs>>

IF !llESC
   \Poet adres: <<RECC(lcAliasD)>>
   \Poet soubor: <<RECC(lcAlias)>>
   \

@ 1,0 SAY "Vstupn adres(e): "+lcDirs
@ 2,0 SAY "Poet adres: "+STR(RECC(lcAliasD),11)
@ 3,0 SAY "Poet soubor: "+STR(RECC(lcAlias),11)
ENDIF

USE IN (lcAliasD)
RELE ARRAY laFiles(1)

IF !llESC
   lcErr=ON("ERROR")
   ON ERROR llErr=.T.

   * Nyn projdi seznam soubor a porovnej je
   SELE (lcAlias)
   INDEX ON XX001 TAG I01 && Vytvo index dle velikosti souboru
   SCAN WHILE !llESC FOR !DELE()
        lcFile=ALLT(XX000)
        @ 4,0 SAY LEFT(XX000,120)
        @ 5,3 SAY SPACE(120)
        llErr=.F.
        lcPom=FILETOSTR(lcFile)
        IF llErr
           DELE NEXT 1
           LOOP
        ENDIF
        liRecno=RECNO()
        liy=XX001
        llFirst=.T.
        SKIP 1     
        SCAN WHILE XX001=liy FOR !DELE() AND !llESC
             lcFile2=ALLT(XX000)
             @ 5,3 SAY LEFT(XX000,120)
             llErr=.F.
             lcPom2=FILETOSTR(lcFile2)
             IF llErr
                LOOP
             ENDIF
             IF lcPom==lcPom2
                IF llFirst
                   llFirst=.F.
                   \
                   \<<lcFile>>
                ENDIF
                \<<CHR(9)+lcFile2>>
                DELE NEXT 1
             ENDIF
        ENDSCAN
     
        GO (liRecno) && Sko na pvodn vtu
   ENDSCAN
   IF EMPTY(lcErr)
      ON ERROR
   ELSE
      ON ERROR &lcErr.
   ENDIF
ENDIF

USE IN (lcAlias)

IF llESC
   \Penos peruen uivatelem.
ENDIF

liT2=SECO()
\
\as: <<liT2-liT1>>
__StopDoc()

IF lcSESC="ON"
   SET ESCAPE ON
ELSE
   SET ESCAPE OFF
ENDIF
ON ESCAPE &lcOESC.
RELE llESC


******************************************
PROCEDURE __StartDoc(lcFile)
* lcFile - Nzev vstupnho souboru
LOCAL llErr,lcErr,lcSF
SET CONSOLE OFF
IF !EMPTY(lcFile)
   SET TEXTMERGE ON
   ON ERROR llErr=.T.
   lcSF=SET("SAFETY")
   SET SAFETY OFF
   SET TEXTMERGE TO (lcFile)
   IF EMPTY(lcErr)
      ON ERROR
   ELSE
      ON ERROR &lcErr.
   ENDIF
   IF lcSF=="ON"
      SET SAFETY ON
   ELSE
      SET SAFETY OFF
   ENDIF
ELSE
   llErr=.T.
ENDIF
RETURN !llErr
ENDPROC

******************************************
PROCEDURE __StopDoc
SET CONSOLE OFF
SET TEXTMERGE TO
SET TEXTMERGE OFF
ENDPROC